# Appfarm Client

The Appfarm Client interprets what has been developed in Appfarm Create and generates the apps that end-users access in their browser. There is a separate version of the Appfarm Client for every environment that is activated in your solution. This is one of the key elements that allows you to develop and test separately from production.

When you click the blue Play icon (Preview App) in the toolbar when developing an app in Appfarm Create, the Appfarm Client for your Development environment is launched. The Appfarm Client maintains communication with the server in order to persist objects and receive updates. In Development, the client has hot reload enabled by default. This way, the client will automatically refresh when you make changes to the app in Appfarm Create.

When updates are made to the Appfarm platform, this typically involves an update to the Appfarm Client as well. These updates are automatically applied to Development and are applied to other environments as you deploy. Such updates are made clear for each environment under [Deploy](/reference/operations/deploy.md).

If you are logged in and navigate to the root URL of the Appfarm Client for a solution, one of two things will occur. If the solution has just one app you will be redirected to that app. If the solution consists of multiple apps you will be shown a list of the apps so you can choose which one you would like to access.

If you are not logged in, you will be first required to authenticate, and the behaviour above will then apply. If a default app has been assigned for that environment, you will be redirected to that app instead of the authentication page.

The Appfarm Client also includes its own [Developer Tools](/reference/appfarm-client/developer-tools-for-apps.md), a helpful interface for understanding what is happening in your app and debugging issues.&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.appfarm.io/reference/appfarm-client.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
